const co = require("co");
var request = require("request");
const sha256 = require('sha256');
var urlencode = require('urlencode');
const system = require("../system");
class baiduClient {
  constructor() {
    this.pushlogSve = system.getObject("service.common.pushlogSve");
  }
  
  //2020 1027 laolan 调用百度网关
  async baiduPost( path, actionBody) {
    console.log('actionBody++',actionBody)
    let domain = "https://gwgp-mwnn9gk4o4e.i.bdcloudapi.com";
    let authorization ="bce-auth-v1";
    let accessKey =  "ff2571490b4c4fb5add57385dc5e8f66";
    let secretKey = "9d86f04a85db4cdfa95ba8ad28009188";
    let timestamp = new Date().toISOString();
    let extime = 1800;

    var signArr = [];
    var keys = Object.keys(actionBody).sort();
    if (keys.length == 0) {
      return system.getResult(null, "请求参数信息为空");
    }
    for (let k = 0; k < keys.length; k++) {
      const tKey = keys[k];
      if (tKey != "sign" && actionBody[tKey] && !(typeof (actionBody[tKey]) === "object")) {
        signArr.push(urlencode(tKey) + "=" + urlencode(actionBody[tKey]));
      }
    }
    let resultSignStr = signArr.join("&");
    console.log('resultSignStr+++',resultSignStr)
    // SigningKey = HMAC-SHA256-HEX(sk, authStringPrefix)
    // authStringPrefix代表认证字符串的前缀部分，即：bce-auth-v1/{accessKeyId}/{timestamp}/{expirationPeriodInSeconds}。
    //  CanonicalRequest = HTTP Method + "\n" + CanonicalURI + "\n" + CanonicalQueryString + "\n" + CanonicalHeaders
    // signature = HMAC-SHA256-HEX(SigningKey,CanonicalRequest)

    let authStringPrefix = authorization + "/" + accessKey + "/" + timestamp + "/" + extime;
    let signingKey = await sha256(secretKey,authStringPrefix);
    let newResultSignStr = resultSignStr.replace(/&/g,',')
    let canonicalQueryString = path + ','+ newResultSignStr;
    console.log('canonicalQueryString+++',canonicalQueryString)
    let canonicalHeaders = {
      host:urlencode(domain)
    }
    let canonicalRequest = "POST" + "\n" + path + "\n" + canonicalQueryString + "\n" + canonicalHeaders + "\n" ;
    let signature = await sha256(signingKey,canonicalRequest);
    path = domain + path;
    console.log('path+++',path)
    var param = {
      data: actionBody,
      timeout: 20000,
      headers: {
        Authorization: authStringPrefix + "/" + "x-bce-date/" + signature,
        accept: 'application/json'
      }
    };
    console.log('param+++',param, "______________峰擎---百度云参数_______");
    var result = await request.post(path, param);
    console.log('result+++',JSON.stringify(result), "______________峰擎---百度云返回结果_______");
    console.log('result-------',result);
    return result;
  }

  //百度接口 2020-10-27 laolan
  async baiduReqbyget(obj, cbk) {
    console.log('obj+++',obj)
    var path = obj.path;
    var reqbody = obj.reqbody;
    try {
      var res = await this.baiduPost( path, reqbody, {
        timeout: 10000, // default 3000 ms 修改3000为10000，原因ConfirmIcpIntention BizIds 超过5条会超时
        formatAction: true, // default true, format the action to Action
        formatParams: true, // default true, format the parameter name to first letter upper case
        method: 'POST', // set the http method, default is GET
        headers: {}, // set the http request headers
      });
      console.log('baidu++++res+++',res)
      this.pushlogSve.createDb({
        op: "new-baiduReqbyget",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: JSON.stringify(res),
        returnType: '1',
        logLevel: '1',
        opTitle: "new-baiduReqbyget推送百度信息返回成功"
      });
      return system.getResultSuccess(res);
    } catch (e) {
      this.pushlogSve.createFailLogDb({
        appid: obj.appInfo ? obj.appInfo.uapp_id || "" : "",
        appkey: obj.appInfo ? obj.appInfo.uapp_key || "" : "",
        requestId: obj.requestId || "",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: "error:" + JSON.stringify(e),
        clientIp: obj.clientIp || "",
        failType: 1,
        opTitle: "new-baiduReqbyget推送百度信息返回异常",
        pushNumber: obj.pushNumber || 1
      });
      return system.getResultFail(-200, "出现异常，error：" + e.stack);
    }
  }
}
module.exports = baiduClient;
